<template>
    <div class="contenido">
        <section>
            <filtro-mascota @cambio-filtro="setFiltro"></filtro-mascota>
        </section>
        <section>
            <base-card>
                <div class="controls">
                    <base-button mode="delineado" @click="cargarMascotas">Refrescar</base-button>
                    <base-button link to="/registro_mascota">Registrar mascota</base-button>
                </div>
                <div v-if="enCarga">
                    <base-spinner></base-spinner>
                </div>
                <ul v-else-if="existenMascotas && filtradoMascotas.length>0">
                    <item-mascota v-for="mascota in filtradoMascotas" 
                    :key="mascota.id" 
                    :id="mascota.id"
                    :nombre="mascota.nombre"
                    :edad="mascota.edad"
                    :especie="mascota.especie"
                    :descripcion="mascota.descripcion"></item-mascota>
                </ul>
                <h3 v-else>No se encuentran mascotas disponibles por el momento.</h3>
            </base-card>
        </section>
    </div>
</template>
<script>
import ItemMascota from '../../components/mascotas/ItemMascota.vue';
import FiltroMascota from '../../components/mascotas/FiltroMascota.vue';

export default {
    components:{
        ItemMascota,
        FiltroMascota
    },
    data(){
        return{
            enCarga: false,
            filtrosActivos:{
                perro:true,
                gato:true
            }
        };
    },
    computed:{
        filtradoMascotas(){
            const mascotas= this.$store.getters['mascotas/mascotas'];
            console.log(mascotas);
            return mascotas.filter(mascota=>{
                if(this.filtrosActivos.perro&&mascota.especie.includes('perro')){
                    return true;
                }
                if(this.filtrosActivos.gato&&mascota.especie.includes('gato')){
                    return true;
                }
                return false;
            });
        },
        existenMascotas(){
            return !this.enCarga && this.$store.getters['mascotas/existenMascotas'];
        }
    },
    created(){
        this.cargarMascotas();
    },
    methods:{
        setFiltro(filtroActualizado){
            this.filtrosActivos=filtroActualizado;
        },
        async cargarMascotas(){
            this.enCarga=true;
            await this.$store.dispatch('mascotas/cargarMascotas');
            this.enCarga=false;
        }
    }
}
</script>
<style scoped>
.contenido{
    margin-top: 5rem;
}
/* .contenido section{
    display: inline-block;
} */
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}

.controls {
  display: flex;
  justify-content: space-between;
}
</style>